Package tigase.server.ext

# Class AbstractCompDBRepository

java.lang.Object
tigase.db.comp.ConfigRepository<Item>
tigase.db.comp.UserRepoRepository<CompRepoItem>
tigase.server.ext.AbstractCompDBRepository

All Implemented Interfaces:
  `Iterable<CompRepoItem>`, `ComponentRepository<CompRepoItem>`, `Repository`, `Initializable`, `UnregisterAware`

Direct Known Subclasses:
  `CompCompDBRepository`, `ServerCompDBRepository`

public class AbstractCompDBRepository extends UserRepoRepository<CompRepoItem>
Created: Oct 24, 2009 3:55:41 PM

Author:
  Artur Hefczyc

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface tigase.db.Repository

  `Repository.Meta, Repository.SchemaId`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ITEMS_IMPORT_FILE`

  ### Fields inherited from class tigase.db.comp.UserRepoRepository

  `repo, REPO_CLASS_PROP_KEY, REPO_URI_PROP_KEY`

  ### Fields inherited from class tigase.db.comp.ConfigRepository

  `autoReloadInterval, items, itemsHash`

  ### Fields inherited from interface tigase.db.comp.ComponentRepository

  `COMP_REPO_BIND`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractCompDBRepository(String extenalComponentsGroup)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `destroy()`
  Method destroys this instance of ComponentRepository releasing resources allocated for this instance of ComponentRepository if possible
  `String`
  `getConfigKey()`
  `String[]`
  `getDefaultPropetyItems()`
  `CompRepoItem`
  `getItemInstance()`
  Creates a new, uninitialized instance of the repository Item.
  `String`
  `getItemsListPKey()`
  `String`
  `getPropertyKey()`
  `BareJID`
  `getRepoUser()`
  `void`
  `initialize()`
  Method will be called, when bean will be created, configured and ready to use.
  `void`
  `initRepository(String resource_uri, Map<String,String> params)`
  Deprecated.
  `void`
  `loadItemsFromFile()`
  `String`
  `validateItem(CompRepoItem item)`
  Performs Item validation to check whether it meets the repository policy.

  ### Methods inherited from class tigase.db.comp.UserRepoRepository

  `reload, setRepo, store`

  ### Methods inherited from class tigase.db.comp.ConfigRepository

  `addItem, addItemNoStore, addRepoChangeListener, allItems, beforeUnregister, contains, getDefaultItems, getDefaults, getItem, getItemsOld, initItemsMap, isInitialized, itemChanged, iterator, removeItem, removeItemNoStore, removeRepoChangeListener, setAutoloadTimer, setAutoReloadInterval, setItemsOld, setProperties, size, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

- ## Field Details

  - ### ITEMS_IMPORT_FILE

    public static final String ITEMS_IMPORT_FILE
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### AbstractCompDBRepository

    protected AbstractCompDBRepository(String extenalComponentsGroup)

- ## Method Details

  - ### destroy

    public void destroy()
    Description copied from interface: `ComponentRepository`
    Method destroys this instance of ComponentRepository releasing resources allocated for this instance of ComponentRepository if possible

  - ### getConfigKey

    public String getConfigKey()
    Specified by:
      `getConfigKey` in class `ConfigRepository<CompRepoItem>`

  - ### getDefaultPropetyItems

    public String[] getDefaultPropetyItems()
    Overrides:
      `getDefaultPropetyItems` in class `ConfigRepository<CompRepoItem>`

  - ### getItemInstance

    public CompRepoItem getItemInstance()
    Description copied from interface: `ComponentRepository`
    Creates a new, uninitialized instance of the repository Item.
    Returns:
      a new, uninitialized instance of the repository Item.

  - ### getItemsListPKey

    public String getItemsListPKey()
    Overrides:
      `getItemsListPKey` in class `UserRepoRepository<CompRepoItem>`

  - ### getPropertyKey

    public String getPropertyKey()
    Specified by:
      `getPropertyKey` in class `ConfigRepository<CompRepoItem>`

  - ### getRepoUser

    public BareJID getRepoUser()
    Specified by:
      `getRepoUser` in class `UserRepoRepository<CompRepoItem>`

  - ### initRepository

    @Deprecated public void initRepository(String resource_uri, Map<String,String> params) throws DBInitException
    Deprecated.
    Description copied from interface: `Repository`
    Method is deprecated and should not be user any more.
    The method is called to initialize the data repository. Depending on the implementation all the initialization parameters can be passed either via `resource_uri` parameter as the database connection string or via `params` map if the required repository parameters are more complex or both.
    Parameters:
      `resource_uri` - value in most cases representing the database connection string.
      `params` - is a `Map` with repository properties necessary to initialize and perform all the functions. The initialization parameters are implementation dependent.
    Throws:
      `DBInitException` - if there was an error during repository initialization. Some implementations, though, perform so called lazy initialization so even though there is a problem with the underlying repository it may not be signaled through this method call.

  - ### validateItem

    public String validateItem(CompRepoItem item)
    Description copied from interface: `ComponentRepository`
    Performs Item validation to check whether it meets the repository policy. If validation is successful the method returns `null`, otherwise it returns an error description.
    Specified by:
      `validateItem` in interface `ComponentRepository<CompRepoItem>`
    Overrides:
      `validateItem` in class `ConfigRepository<CompRepoItem>`
    Parameters:
      `item` - is an `Item` object to perform validation checking upon.
    Returns:
      `null` on success and an error message otherwise.

  - ### initialize

    public void initialize()
    Description copied from interface: `Initializable`
    Method will be called, when bean will be created, configured and ready to use.
    Specified by:
      `initialize` in interface `Initializable`
    Overrides:
      `initialize` in class `ConfigRepository<CompRepoItem>`

  - ### loadItemsFromFile

    public void loadItemsFromFile()